NUMERIC DIGITS 10
OPTIONS "C_CALL LABELCHECK WINFUNC NOSOURCE"

DO
	/* Register GetSystemMetrics() */
	FUNCDEF('GetSystemMetrics', '32, 32u', 'user32')

	CATCH FAILURE
		CONDITION("M")
		RETURN
END

/* Call GetSystemMetrics() to return the width of a border
 * for a window that can be resized. If the window can't be
 * resized, then pass SM_CXBORDER (5) instead.
 */
borderwidth = GetSystemMetrics(32 /* SM_CXFRAME */)
SAY "Border width for sizing window:" borderwidth

/* Call GetSystemMetrics() to return the height of a border
 * for a window that can be resized. If the window can't be
 * resized, then pass SM_CYBORDER (6) instead.
 */
borderheight = GetSystemMetrics(33 /* SM_CYFRAME */)
SAY "Border height for sizing window:" borderheight

/* Call GetSystemMetrics() to return the height of the caption
 * area of the window.
 */
caption = GetSystemMetrics(4 /* SM_CYCAPTION */)
SAY "Height of caption:" caption

/* Call GetSystemMetrics() to return the height of the menu
 * bar.
 */
menu = GetSystemMetrics(15 /* SM_CYMENU */)
SAY "Height of menu:" menu

/* NOTE: A window's height = The height of its client area + (2 * borderheight) +
 * caption. And if it has a menu, then add menu to the height. A window's width = the
 * width of its client area + (2 * borderwidth)
 */

RETURN


/*

LOGFONT = "32, 32, 32, 32, 32, 8, 8, 8, 8, 8, 8, 8, 8, char[32]"
NONCLIENTMETRICS = "32u, 32, 32, 32, 32, 32, struct LOGFONT, 32, 32, struct LOGFONT, 32, 32, struct LOGFONT, struct LOGFONT, struct LOGFONT"

/* Register and call SystemParametersInfoA() to return the NONCLIENTMETRICS struct.
 * Note: When we use SystemParametersInfoA() to return this info. The third
 * argument must be 'struct NONCLIENTMETRICS dual'. We're going to give this
 * function a REXX name of GetClientMetrics().
 */
FUNCDEF('GetClientMetrics', '32u, 32u, 32u, struct NONCLIENTMETRICS dual, 32u', 'user32', 'SystemParametersInfoA')
DROP LOGFONT NONCLIENTMETRICS


/* ========= Have Windows fill in a NONCLIENTMETRICS ======== */

/* Initialize the NONCLIENTMETRICS struct in a rexx
 * variable named 'metrics'. Actually, all
 * SystemParametersInfo needs is to initialize
 * the first field to the size of the struct. But
 * we'll have to initialize all fields. Let's just
 * set them all to 0 by setting the stem itself to
 * 0. NOTE: If some compound variable of metrics.
 * had been set prior to this, we would need to do
 *
 * DROP metrics.
 *
 * before doing metrics. = 0
 */
metrics. = 0
metrics.1 = 340

/* Fill in the NONCLIENTMETRICS in our rexx variable named 'metrics' */
IF GetClientMetrics(41 /* SPI_GETNONCLIENTMETRICS */, , metrics) == 1 THEN DO

   /* Print out some information */
   SAY "Window border width:" metrics.2
   SAY "Window caption width:" metrics.5
   SAY "Window caption height:" metrics.6
   SAY "Window menu height:" metrics.12

   /* NOTE: A window's height = The height of its client area + (2 * metrics.2) +
    * metrics.6. And if it has a menu, then add metrics.12. A window's width = the
    * width of its client area + (2 * metrics.2)
    */

END
ELSE SAY "Can't get window metrics"

RETURN
*/